
window.onload = function () {
    var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"));
    initSpread(spread);
};

function initSpread(spread) {
    var spreadNS = GC.Spread.Sheets;

    var sheet = spread.getSheet(0);

    window.spread = spread;
    var source = [
        { Course: "Calculus", Term: 1, Credit: 5, Score: 80, Teacher: "Nancy Feehafer" },
        { Course: "P.E.", Term: 1, Credit: 3.5, Score: 85, Teacher: "Andrew Cencini" },
        { Course: "Political Economics", Term: 1, Credit: 3.5, Score: 95, Teacher: "Jan Kotas" },
        { Course: "Basic of Computer", Term: 1, Credit: 2, Score: 85, Teacher: "Steven Thorpe" },
        { Course: "Micro-Economics", Term: 1, Credit: 4, Score: 62, Teacher: "Jan Kotas" },
        { Course: "Linear Algebra", Term: 2, Credit: 5, Score: 73, Teacher: "Nancy Feehafer" },
        { Course: "Accounting", Term: 2, Credit: 3.5, Score: 86, Teacher: "Nancy Feehafer" },
        { Course: "Statistics", Term: 2, Credit: 5, Score: 85, Teacher: "Robert Zare" },
        { Course: "Marketing", Term: 2, Credit: 4, Score: 70, Teacher: "Laura Giussani" }
    ];
    spread.suspendPaint();
    var table = sheet.tables.addFromDataSource("Table1", 2, 1, source, {
        showFooter: false,
        showHeader: true,
        showResizeHandle: true,
    });
    
    spread.resumePaint();

    var tablefromCurrentSpreadRef = spread.getActiveSheet().tables.findByName("Table1");
    var tableRange = tablefromCurrentSpreadRef.range();
    var data = spread.getActiveSheet().getArray(tableRange.row, tableRange.col, tableRange.rowCount, tableRange.colCount);

    var columns = tablefromCurrentSpreadRef.toJSON().columns;
    console.log(mapToObjectArray(data, columns));

}


function mapToObjectArray(data, columns) {
    const header = data[0];  // The first row is the header
    const rows = data.slice(1); // All other rows are the data

    return rows.map(row => {
        const obj = {};
        columns.forEach((column, index) => {
            obj[column.dataField] = row[index];
        });
        return obj;
    });
}
